﻿* Encoding: UTF-8.
*Plot latents
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_PLOTPC*/***********************************************.
define !KO_plotpc(vars= !charend('/') /center= !charend('/'))
!if (!tail(!vars)=!null !or !tail(!tail(!tail(!vars)))<>!null) !then
-echo '>ERROR. В VARS может быть указано только 2 или 3 переменные.'.
!else
-matrix.
-get vars /vari= !vars /names= names.
 !if (!center<>'NO') !then
- comp mean= csum(vars)/nrow(vars).
- comp vars= vars-kroneker(mean,make(nrow(vars),1,1)).
 !ifend
-call eigen(sscp(vars),eivec,eival).
-print eival /title= 'Собственные числа главных компонент:' /format= f8.4.
-print eivec /title= 'Собственные векторы главных компонент:' /rnames= names /format= f8.4.
-comp rawcomp= vars*eivec.
-comp eivec= t(eivec).
 !if (!center<>'NO') !then
- comp vars= vars+kroneker(mean,make(nrow(vars),1,1)).
 !ifend
-save {make(nrow(vars),1,0),vars} /outfile= * /vari= element !vars.
-loop pc= 1 to ncol(vars).
- comp pccoord= kroneker(rawcomp(:,pc),eivec(pc,:)).
  !if (!center<>'NO') !then
-  comp pccoord= pccoord+kroneker(mean,make(nrow(vars),1,1)).
  !ifend
- save {make(nrow(vars),1,pc),pccoord} /outfile= * /vars= element !vars.
-end loop.
-end matrix.
-format element (f8).
-var lev element (nom) !vars (sca).
-val lab element 0 'Облако' 1 'Компонента 1' 2 'Компонента 2' 3 'Компонента 3'.
 !let !list= !null
 !do !w !in (!vars) !let !list= !conc(!list,' with ',!w) !doend
-graph /scatter !if (!tail(!tail(!vars))<>!null) !then (xyz) !ifend = !tail(!list) by element.
!ifend
!enddefine.

*/*!KO_PLOTDIS*/***********************************************.
define !KO_plotdis(vars= !charend('/') /grvar= !charend('/'))
!if (!tail(!vars)=!null !or !tail(!tail(!tail(!vars)))<>!null) !then
-echo '>ERROR. В VARS может быть указано только 2 или 3 переменные.'.
!else
-matrix.
-get vars /vari= !vars /names= names.
-get gr /var= !grvar.
-comp dummy= design(gr).
-comp mean= csum(vars)/nrow(vars).
-comp vars= vars-kroneker(mean,make(nrow(vars),1,1)).
-comp w= make(ncol(vars),ncol(vars),0).
-loop i= 1 to ncol(dummy).
- comp varsi= vars&*kroneker(dummy(:,i),make(1,ncol(vars),1)).
- comp sum= kroneker(csum(varsi),make(ncol(vars),1,1)).
- comp scpdevi= sscp(varsi)-sum&*t(sum)/csum(dummy(:,i)).
- comp w= w+scpdevi.
-end loop.
-comp b= (sscp(vars)-w).
-comp m= rmin({ncol(dummy)-1,ncol(vars)}).
-comp invc= inv(chol(w)).
-call eigen(t(invc)*b*invc,e,eival).
-print eival(1:m) /title= 'Собственные числа дискриминантных функций:' /format= f8.4.
-comp eivec= (invc*e)(:,1:m).
-comp eivec= eivec/kroneker(sqrt(cssq(eivec)),make(ncol(vars),1,1)).
-print eivec /title= 'Собственные векторы дискриминантных функций (нормированы к SS=1):' /rnames= names /format= f8.4.
-comp rawdis= vars*eivec.
-comp eivec= t(eivec).
-comp vars= vars+kroneker(mean,make(nrow(vars),1,1)).
-save {make(nrow(vars),1,0),gr,vars} /outfile= * /vari= element !grvar !vars.
-loop dis= 1 to m.
- comp discoord= kroneker(rawdis(:,dis),eivec(dis,:)).
- comp discoord= discoord+kroneker(mean,make(nrow(vars),1,1)).
- save {make(nrow(vars),1,dis),make(nrow(vars),1,-999),discoord} /outfile= * /vars= element !grvar !vars.
-end loop.
-end matrix.
-recode !grvar (-999=sysmis).
-exec.
-format element (f8).
-var lev element (nom) !vars (sca).
-val lab element 0 'Облако' 1 'Дискриминанта 1' 2 'Дискриминанта 2' 3 'Дискриминанта 3'.
 !let !list= !null
 !do !w !in (!vars) !let !list= !conc(!list,' with ',!w) !doend
-graph /scatter !if (!tail(!tail(!vars))<>!null) !then (xyz) !ifend = !tail(!list) by element.
!ifend
!enddefine.
